package org.webharvest.runtime.scripting;

import org.python.core.PyException;
import org.python.core.PyInteger;
import org.python.core.PyObject;
import org.python.util.PythonInterpreter;
import org.webharvest.exception.ScriptException;

import java.util.Map;

/**
 * javascript scripting engine based on Rhino.
 */
public class JythonScriptEngine extends ScriptEngine {

    private PythonInterpreter interp = new PythonInterpreter();

    public JythonScriptEngine(Map context) {
        super(context);
    }

    public void setVariable(String name, Object value) {
        interp.set(name, value);
    }

    public Object eval(String expression) {
        pushAllVariablesFromContextToScriptEngine();
        try {
            return interp.eval(expression);
        } catch (PyException e) {}
        try {
            interp.exec("if True:\n" + expression);
        } catch (PyException e) {
            throw new ScriptException("Error During Jython Script Execution: " + e.toString(), e);
        }
        return null;
    }

}